<template>
  <Toolbar class="SearchOrCreateBar">
    <template #start>
      <!-- Quick search input  -->
      <div class="p-inputgroup">
        <span class="p-inputgroup-addon">
          <i
            :class="[
              props.loading ? 'pi pi-spin pi-spinner' : 'mdi mdi-magnify',
            ]"
          />
        </span>
        <PInputText
          v-model="name"
          v-focus
          type="text"
          :title="t(`action.search`)"
          :placeholder="t(`action.search`)"
        />
        <PButton
          v-if="name"
          class="p-button-warning"
          icon="mdi mdi-close"
          :title="t('action.clear')"
          @click="name = ''"
        />
      </div>

      <slot name="toolbar-start" />
    </template>

    <template #end>
      <slot name="toolbar-end" />
    </template>
  </Toolbar>

  <transition v-if="$slots.create" name="fade">
    <slot v-if="!exists" name="create" />
  </transition>

  <component :is="ordered ? 'ol' : 'ul'" class="SearchOrCreateList">
    <slot
      v-for="resource in props.resources"
      :key="resource.id"
      name="resource"
      :resource="resource"
    >
      <li class="SearchOrCreate__Item">
        <router-link
          v-slot="{ navigate }"
          :to="{ ...ROUTES.RESOURCE, params: { uuid: resource.id } }"
          custom
        >
          <a
            class="SearchOrCreate__ItemLink"
            @click="navigate"
            @keypress.enter="navigate"
          >
            <slot name="link" :resource="resource">
              <span class="SearchOrCreate__ItemName">{{
                resource[props.labelProperty]
              }}</span>
            </slot>
          </a>
        </router-link>
      </li>
    </slot>
  </component>

  <PPaginator
    v-if="totalRecords > props.resources.length"
    :total-records="totalRecords"
    :rows="PER_PAGE_COUNT"
    @page="onPage"
  />
</template>

<script lang="ts" setup>
import { useI18n } from 'vue-i18n'
import { computed, ref, watch, onUnmounted, defineEmits } from 'vue'
import { Resource, CollectionParam, PER_PAGE_COUNT } from '@/api/resources'
import { useRouter } from 'vue-router'
import { ROUTES } from '@/plugins'
import Toolbar from 'primevue/toolbar/Toolbar.vue'

const router = useRouter()
const { t } = useI18n()
const props = defineProps<{
  resourceType: string
  labelProperty: string
  totalRecords: number
  resources: Array<Resource & Record<string, unknown>>
  loading: boolean
  ordered?: true
}>()

const page = ref(1)
const name = ref('')

const emits = defineEmits<{
  (e: 'search', queryParams: CollectionParam): void
}>()

/**
 * True if Search term is a client
 */
const exists = computed(() =>
  props.resources.find(
    (resource) =>
      (resource[props.labelProperty] as string)?.toLocaleLowerCase() ===
      name.value.toLocaleLowerCase()
  )
)

function search() {
  emits('search', { page: page.value, [props.labelProperty]: name.value })
}

/**
 * When user click on pagination, update page index in order to trigger API call
 */
function onPage(event: { page: number }) {
  // event.page is zero-based, API is one-based
  page.value = event.page + 1
  search()
}

/**
 * Debounced search
 */
let timeout = 0
watch(name, () => {
  if (timeout) window.clearTimeout(timeout)
  timeout = window.setTimeout(search, 300)
})
onUnmounted(() => window.clearTimeout(timeout))
</script>

<style lang="scss" scoped>
@use '../../style/variables' as v;

.SearchOrCreate {
  &List {
    display: grid;
    margin: 0;
    padding: 0;
    list-style: none;
  }

  &__Item {
    border-top: solid 1px var(--surface-50);

    &Link {
      display: inline-flex;
      justify-content: stretch;
      width: 100%;
      height: 100%;
      padding: v.$spacing;
      cursor: pointer;
    }

    &Name {
      display: block;
      color: var(--text-color);
      font-weight: 500;
      text-decoration: none;
    }

    &:hover {
      background-color: var(--surface-50);
    }

    &:first-child {
      border-top: none;
    }
  }
}
</style>
